IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRMitsubishi136 Class Reference

Class for handling detailed Mitsubishi 136-bit A/C messages. More...

`#include <ir_Mitsubishi.h>`

Collaboration diagram for IRMitsubishi136:
[legend]

## Public Member Functions
| IRMitsubishi136 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | stateReset (void)
| Reset the state of the remote to a known good state/sequence. More...
void | send (const uint16_t repeat=kMitsubishi136MinRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | on (void)
| Set the requested power state of the A/C to on. More...
void | off (void)
| Set the requested power state of the A/C to off. More...
void | setPower (const bool on)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setTemp (const uint8_t degrees)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setFan (const uint8_t speed)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setSwingV (const uint8_t position)
| Set the Vertical Swing mode of the A/C. More...
uint8_t | getSwingV (void) const
| Get the Vertical Swing mode of the A/C. More...
void | setQuiet (const bool on)
| Set the Quiet mode of the A/C. More...
bool | getQuiet (void) const
| Get the Quiet mode of the A/C. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t *data)
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the internal state into a human readable string. More...

## Static Public Member Functions
static bool | validChecksum (const uint8_t *data, const uint16_t len=kMitsubishi136StateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static uint8_t | convertSwingV (const stdAc::swingv_t position)
| Convert a stdAc::swingv_t enum into it's native setting. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...
static stdAc::swingv_t | toCommonSwingV (const uint8_t pos)
| Convert a native vertical swing postion to it's common equivalent. More...

## Private Member Functions
void | checksum (void)
| Calculate the checksum for the current internal state of the remote. More...

## Private Attributes
IRsend | _irsend
| Instance of the IR send class. More...
Mitsubishi136Protocol | _

## Detailed Description

Class for handling detailed Mitsubishi 136-bit A/C messages.

## Constructor & Destructor Documentation

## ◆ IRMitsubishi136()

IRMitsubishi136::IRMitsubishi136 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |
| explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRMitsubishi136::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calibrate()

int8_t IRMitsubishi136::calibrate | ( | void |  | ) |
| inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRMitsubishi136::checksum | ( | void |  | ) |
| private

Calculate the checksum for the current internal state of the remote.

## ◆ convertFan()

uint8_t IRMitsubishi136::convertFan | ( | const stdAc::fanspeed_t | speed | ) |
| static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRMitsubishi136::convertMode | ( | const stdAc::opmode_t | mode | ) |
| static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertSwingV()

uint8_t IRMitsubishi136::convertSwingV | ( | const stdAc::swingv_t | position | ) |
| static

Convert a stdAc::swingv_t enum into it's native setting.

Parameters

  [in] | position | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ getFan()

uint8_t IRMitsubishi136::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed/mode.

## ◆ getMode()

uint8_t IRMitsubishi136::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getPower()

bool IRMitsubishi136::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getQuiet()

bool IRMitsubishi136::getQuiet | ( | void |  | ) | const

Get the Quiet mode of the A/C.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint8_t * IRMitsubishi136::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## ◆ getSwingV()

uint8_t IRMitsubishi136::getSwingV | ( | void |  | ) | const

Get the Vertical Swing mode of the A/C.

Returns
  The native position/mode setting.

## ◆ getTemp()

uint8_t IRMitsubishi136::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees celsius.

## ◆ off()

void IRMitsubishi136::off | ( | void |  | ) |

Set the requested power state of the A/C to off.

## ◆ on()

void IRMitsubishi136::on | ( | void |  | ) |

Set the requested power state of the A/C to on.

## ◆ send()

void IRMitsubishi136::send | ( | const uint16_t | repeat = `kMitsubishi136MinRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setFan()

void IRMitsubishi136::setFan | ( | const uint8_t | speed | ) |

Set the speed of the fan.

Parameters

  [in] | speed | The desired setting.

## ◆ setMode()

void IRMitsubishi136::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setPower()

void IRMitsubishi136::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setQuiet()

void IRMitsubishi136::setQuiet | ( | const bool | on | ) |

Set the Quiet mode of the A/C.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRMitsubishi136::setRaw | ( | const uint8_t * | data | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | data | A valid code for this protocol.

## ◆ setSwingV()

void IRMitsubishi136::setSwingV | ( | const uint8_t | position | ) |

Set the Vertical Swing mode of the A/C.

Parameters

  [in] | position | The position/mode to set the swing to.

## ◆ setTemp()

void IRMitsubishi136::setTemp | ( | const uint8_t | degrees | ) |

Set the temperature.

Parameters

  [in] | degrees | The temperature in degrees celsius.

## ◆ stateReset()

void IRMitsubishi136::stateReset | ( | void |  | ) |

Reset the state of the remote to a known good state/sequence.

## ◆ toCommon()

stdAc::state_t IRMitsubishi136::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRMitsubishi136::toCommonFanSpeed | ( | const uint8_t | speed | ) |
| static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | speed | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRMitsubishi136::toCommonMode | ( | const uint8_t | mode | ) |
| static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonSwingV()

stdAc::swingv_t IRMitsubishi136::toCommonSwingV | ( | const uint8_t | pos | ) |
| static

Convert a native vertical swing postion to it's common equivalent.

Parameters

  [in] | pos | A native position to convert.

Returns
  The common vertical swing position.

## ◆ toString()

String IRMitsubishi136::toString | ( | void |  | ) | const

Convert the internal state into a human readable string.

Returns
  A string containing the settings in human-readable form.

## ◆ validChecksum()

bool IRMitsubishi136::validChecksum | ( | const uint8_t * | data,
|  | const uint16_t | len = `kMitsubishi136StateLength`
| ) |  |
| static

Verify the checksum is valid for a given state.

Parameters

  [in] | data | The array to verify the checksum of.
  [in] | len | The length of the data array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

Mitsubishi136Protocol IRMitsubishi136::_
| private

## ◆ _irsend

IRsend IRMitsubishi136::_irsend
| private

Instance of the IR send class.

The documentation for this class was generated from the following files:

- src/ir_Mitsubishi.h
- src/ir_Mitsubishi.cpp